<?php

namespace App\Dto\Output;

use ApiPlatform\Metadata\Get;
use App\Entity\OrganizationalUnit;
use Symfony\Component\Serializer\Annotation\Groups;

#[Get(shortName: 'OrganizationalUnit')]
final class OrganizationalUnitOutput extends AbstractOutput
{
    #[Groups(['organizational-unit:read'])]
    public string $name;

    #[Groups(['organizational-unit:read'])]
    public string $type;

    #[Groups(['organizational-unit:read'])]
    public ?OrganizationalUnit $parent = null;

    #[Groups(['organizational-unit:read'])]
    public string $path;

    #[Groups(['organizational-unit:read'])]
    public \DateTime $createAt;

    #[Groups(['organizational-unit:read'])]
    public ?string $createBy = null;

    public function __construct(OrganizationalUnit $organizationalUnit)
    {
        parent::__construct($organizationalUnit);

        $this->name = $organizationalUnit->getName();
        $this->type = $organizationalUnit->getType();
        $this->parent = $organizationalUnit->getParent();
        $this->path = $organizationalUnit->getPath();
        $this->createAt = $organizationalUnit->getCreatedAt();
        $this->createBy = $organizationalUnit->getCreatedBy();
    }
}